pcl::tracking::Tracker< PointInT, StateT > Class Template Referenceabstract

Tracker represents the base tracker class. More...

`#include <pcl/tracking/tracker.h>`

Inheritance diagram for pcl::tracking::Tracker< PointInT, StateT >:

## Public Types

using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Tracker< PointInT, StateT > >
using | ConstPtr = shared_ptr< const Tracker< PointInT, StateT > >
using | SearchPtr = typename pcl::search::Search< PointInT >::Ptr
using | SearchConstPtr = typename pcl::search::Search< PointInT >::ConstPtr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudState = pcl::PointCloud< StateT >
using | PointCloudStatePtr = typename PointCloudState::Ptr
using | PointCloudStateConstPtr = typename PointCloudState::ConstPtr
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| Tracker ()
| Empty constructor. More...
void | compute ()
| Base method for tracking for all points given in <setInputCloud (), setIndices ()> using the indices in setIndices () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
void | setSearchMethod (const SearchPtr &search)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
SearchPtr | getSearchMethod ()
| Get a pointer to the point cloud dataset. More...
virtual StateT | getResult () const =0
| Get an instance of the result of tracking. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

std::string | tracker_name_
| The tracker name. More...
SearchPtr | search_
| A pointer to the spatial search object. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename StateT>
class pcl::tracking::Tracker< PointInT, StateT >

Tracker represents the base tracker class.

Author
  Ryohei Ueda

Definition at line 55 of file tracker.h.

## Member Typedef Documentation

## BaseClass

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::BaseClass = PCLBase<PointInT>

Definition at line 63 of file tracker.h.

## ConstPtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::ConstPtr = shared_ptr<const Tracker<PointInT, StateT> >

Definition at line 65 of file tracker.h.

## PointCloudIn

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::PointCloudIn = pcl::PointCloud<PointInT>

Definition at line 70 of file tracker.h.

## PointCloudInConstPtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::PointCloudInConstPtr = typename PointCloudIn::ConstPtr

Definition at line 72 of file tracker.h.

## PointCloudInPtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::PointCloudInPtr = typename PointCloudIn::Ptr

Definition at line 71 of file tracker.h.

## PointCloudState

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::PointCloudState = pcl::PointCloud<StateT>

Definition at line 74 of file tracker.h.

## PointCloudStateConstPtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::PointCloudStateConstPtr = typename PointCloudState::ConstPtr

Definition at line 76 of file tracker.h.

## PointCloudStatePtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::PointCloudStatePtr = typename PointCloudState::Ptr

Definition at line 75 of file tracker.h.

## Ptr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::Ptr = shared_ptr<Tracker<PointInT, StateT> >

Definition at line 64 of file tracker.h.

## SearchConstPtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::SearchConstPtr = typename pcl::search::Search<PointInT>::ConstPtr

Definition at line 68 of file tracker.h.

## SearchPtr

template<typename PointInT , typename StateT >

using pcl::tracking::Tracker< PointInT, StateT >::SearchPtr = typename pcl::search::Search<PointInT>::Ptr

Definition at line 67 of file tracker.h.

## Constructor & Destructor Documentation

## Tracker()

template<typename PointInT , typename StateT >

pcl::tracking::Tracker< PointInT, StateT >::Tracker | ( |  | ) |

inline

Empty constructor.

Definition at line 80 of file tracker.h.

## Member Function Documentation

## compute()

template<typename PointInT , typename StateT >

void pcl::tracking::Tracker< PointInT, StateT >::compute

Base method for tracking for all points given in <setInputCloud (), setIndices ()> using the indices in setIndices ()

Definition at line 30 of file tracker.hpp.

## getClassName()

template<typename PointInT , typename StateT >

const std::string& pcl::tracking::Tracker< PointInT, StateT >::getClassName | ( |  | ) | const

inline protected

Get a string representation of the name of this class.

Definition at line 97 of file tracker.h.

References pcl::tracking::Tracker< PointInT, StateT >::tracker_name_.

Referenced by pcl::tracking::ParticleFilterTracker< PointInT, StateT >::setUseNormal().

## getResult()

template<typename PointInT , typename StateT >

virtual StateT pcl::tracking::Tracker< PointInT, StateT >::getResult | ( |  | ) | const

protected pure virtual

Get an instance of the result of tracking.

Implemented in pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >, and pcl::tracking::ParticleFilterTracker< PointInT, StateT >.

## getSearchMethod()

template<typename PointInT , typename StateT >

SearchPtr pcl::tracking::Tracker< PointInT, StateT >::getSearchMethod | ( |  | ) |

inline protected

Get a pointer to the point cloud dataset.

Definition at line 122 of file tracker.h.

References pcl::tracking::Tracker< PointInT, StateT >::search_.

## initCompute()

template<typename PointInT , typename StateT >

bool pcl::tracking::Tracker< PointInT, StateT >::initCompute

protected virtual

This method should get called before starting the actual computation.

Reimplemented in pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >, pcl::tracking::ParticleFilterTracker< PointInT, StateT >, and pcl::tracking::KLDAdaptiveParticleFilterTracker< PointInT, StateT >.

Definition at line 10 of file tracker.hpp.

## setSearchMethod()

template<typename PointInT , typename StateT >

void pcl::tracking::Tracker< PointInT, StateT >::setSearchMethod | ( | const SearchPtr & | search | ) |

inline protected

Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.

This is optional, if this is not set, it will only use the data in the input cloud to estimate the features. This is useful when you only need to compute the features for a downsampled cloud.

Parameters

  search | a pointer to a PointCloud message

Definition at line 115 of file tracker.h.

References pcl::tracking::Tracker< PointInT, StateT >::search_.

## Member Data Documentation

## search_

template<typename PointInT , typename StateT >

SearchPtr pcl::tracking::Tracker< PointInT, StateT >::search_

protected

A pointer to the spatial search object.

Definition at line 93 of file tracker.h.

Referenced by pcl::tracking::Tracker< PointInT, StateT >::getSearchMethod(), and pcl::tracking::Tracker< PointInT, StateT >::setSearchMethod().

## tracker_name_

template<typename PointInT , typename StateT >

std::string pcl::tracking::Tracker< PointInT, StateT >::tracker_name_

protected

The tracker name.

Definition at line 90 of file tracker.h.

Referenced by pcl::tracking::Tracker< PointInT, StateT >::getClassName(), pcl::tracking::KLDAdaptiveParticleFilterOMPTracker< PointInT, StateT >::KLDAdaptiveParticleFilterOMPTracker(), pcl::tracking::KLDAdaptiveParticleFilterTracker< PointInT, StateT >::KLDAdaptiveParticleFilterTracker(), pcl::tracking::ParticleFilterOMPTracker< PointInT, StateT >::ParticleFilterOMPTracker(), and pcl::tracking::ParticleFilterTracker< PointInT, StateT >::ParticleFilterTracker().

The documentation for this class was generated from the following files:

- pcl/tracking/tracker.h
- pcl/tracking/impl/tracker.hpp